/************************************************************************
Ver.2010.01.10

             Programs in this file were written by Y.Okamoto:
		            2007.10, 2010.11

*************************************************************************/

#ifndef MyEigen_CK
#define MyEigen_CK

#include "mymat.h"

namespace myLib {

	using namespace std;
	using namespace System;
	using namespace System::IO;
	using namespace myLib;


/*****************************************************************

                      pk@

******************************************************************/

class QL_decom {
	public:
		myMat a;
		int n;
		double czero;

		QL_decom();
		QL_decom( double vzero );
		virtual ~QL_decom(){};

		int DoQL( myMat & aa, myMat & EigenVec, myMat & EigenVal, int & n_eigen );
		int doSubQL( int left, int right, double shiftv );

};


/****************************************************************

                    ْliSVDj

	a : (m, n),		U : (m, m),		V : (n, n)

	lambda : (m, 1) or (n, 1); either is OK.

****************************************************************/

void SVD( myMat a, int & rnk,  myMat & U, myMat & V, myMat & lambda, double ckzero = 1.0e-14 ); 


myMat MPInvBySVD( myMat a, 
					double czero = 1.0e-14  //   O
				);


}   //   End of myLib

#endif
